      SUBROUTINE QS20D(U,V,A,B,F,N,IERR)                                QS200010
         INTEGER IERR,N                                                 QS200020
         DOUBLE PRECISION A,B,U,V                                       QS200030
         DIMENSION U(N),V(N)                                            QS200040
         EXTERNAL F,FTF1P,UTQS12                                        QS200050
         INTEGER IN,K,KK,NMAX                                           QS200060
         DOUBLE PRECISION D,D1,F1,F2,P,X                                QS200070
         DATA NMAX/1048576/                                             QS200080
       IERR = 0                                                         QS200090
       IF (N .EQ. 0) GO TO 40                                           QS200100
          IF (N .LE. NMAX) GO TO 10                                     QS200110
             IERR = 65                                                  QS200120
             CALL UTQS12(IERR,16)                                       QS200130
             GO TO 40                                                   QS200140
   10  CONTINUE                                                         QS200150
       D = B - A                                                        QS200160
       D1 = D/N                                                         QS200170
       IN = 1                                                           QS200180
       KK = 1                                                           QS200190
       P = 1.D0                                                         QS200200
       DO 20 K = 1, N                                                   QS200210
          X = A + (K - 1)*D1                                            QS200220
          CALL F(X,F1,F2)                                               QS200230
          U(K) = F1                                                     QS200240
          V(K) = F2                                                     QS200250
   20  CONTINUE                                                         QS200260
       CALL FTF1P(U,V,N,IN,KK,P)                                        QS200270
       DO 30 K = 1, N                                                   QS200280
          U(K) = D1*U(K)                                                QS200290
          V(K) = D1*V(K)                                                QS200300
   30  CONTINUE                                                         QS200310
   40  RETURN                                                           QS200320
      END                                                               QS200330
